Subject: Re: bug#70517: 29.3; suspicious error message from compile command in Emacs 29.3

From: Eli Zaretskii <[email-masked]>
Date: Mon, 22 Apr 2024 22:40:09 +0300

> Date: Mon, 22 Apr 2024 17:55:24 +0200
> From:  Thomas Düssel via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> The following error message appears in the terminal from which emacs was
> started every time I use the 'compile' command:
> 
>  > emacs: writing to child signal FD: Invalid argument
> 
> The compilation itself (via make) works perfectly fine. Only this new
> message is a bit annoying. And so cryptic, isn't it? It did not appear
> up until the latest update.
> 
> This error message (or whatever it is) appears also, when I start emacs
> from a non-X tty (Ctrl + Alt + F2) and with '-Q' option. To be precise,
> it appears when I use 'M-x compile' and for longer compilation processes
> it appears at the end of the compilation, not at the beginning.

When a sub-process exits, Emacs writes to file descriptor which it
monitors with pselect.  This is so we don't miss SIGCHLD for some
reason.  Why in your case this write errors out with EINVAL, I don't
know.  Perhaps Paul (CC'ed) could have some ideas.

If this could happen for benign reasons, maybe we should silently
ignore these errors.